﻿using UnityEngine;

namespace Battlehub.RTGizmos
{
    public abstract class SphereGizmo : BaseGizmo
    {
        protected abstract Vector3 Center
        {
            get;
            set;
        }

        protected abstract float Radius
        {
            get;
            set;
        }

        protected override void DrawOverride()
        {
            base.DrawOverride();

            if (Target == null)
            {
                return;
            }

            Vector3 scale = Target.lossyScale * Radius;

            scale = Vector3.one * Mathf.Max(Mathf.Abs(scale.x), Mathf.Abs(scale.y), Mathf.Abs(scale.z));

            RuntimeGizmos.DrawWireSphereGL(Target.TransformPoint(Center), Target.rotation, scale, LineColor);
        }
    }
}
